### Function Macro

# GLib datalist_set_data_full

#### Declaration

    #define g_datalist_set_data_full (
      dl,
      k,
      d,
      f
    )

#### Description

Sets the data element corresponding to the given string identifier, and the function to be called when the data element is removed.

This function is not directly available to language bindings.

#### Parameters

`dl`

  Type: `-`

  A datalist.

`k`

  Type: `-`

  The string to identify the data element.

`d`

  Type: `-`

  The data element, or `NULL` to remove any previous element corresponding to `k`.

`f`

  Type: `-`

  The function to call when the data element is removed. This function will be called with the data element and can be used to free any memory allocated for it. If `d` is `NULL`, then `f` must also be `NULL`.